<?xml version="1.0" encoding="ISO-8859-1"?>
<!-- Content Stylesheet -->
<!-- Ismael Ghalimi ghalimi@intalio.com -->
<!-- Remy Maucherat remm@apache.org -->
<!-- Copyright (c) Intalio Inc. 1999 -->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">


  <!-- Include document for document transformation, widgets for some
       simple HTML styles (e-mail, url, etc
    -->
  <xsl:include href="document.xsl"/>
  <xsl:include href="widgets.xsl"/>


  <xsl:output method="html" indent="no"/>


  <!-- Color -->
  <xsl:variable name="color-alpha">#ffffff</xsl:variable>
  <xsl:variable name="color-beta" select="'#ffffff'"/>
  <xsl:variable name="color-gamma" select="'#424264'"/>
  <xsl:variable name="color-delta" select="'#54547f'"/>
  <xsl:variable name="color-epsilon" select="'#bfbffe'"/>
  <xsl:variable name="color-a" select="'#444466'"/>
  <xsl:variable name="color-b" select="'#4d4d73'"/>
  <xsl:variable name="color-c" select="'#565680'"/>
  <xsl:variable name="color-d" select="'#5e5e8c'"/>
  <xsl:variable name="color-e" select="'#676799'"/>
  <xsl:variable name="color-f" select="'#6f6fa6'"/>
  <xsl:variable name="color-g" select="'#7878b3'"/>
  <xsl:variable name="color-h" select="'#8080bf'"/>
  <xsl:variable name="color-i" select="'#8989cc'"/>
  <xsl:variable name="color-j" select="'#9292d9'"/>
  <xsl:variable name="color-k" select="'#9a9ae6'"/>
  <xsl:variable name="color-l" select="'#a2a2f2'"/>
  <xsl:variable name="color-m" select="'#ababff'"/>
  <xsl:variable name="color-link" select="'#565680'"/>


  <!-- Internal subset is broken, so resorting to this for a while -->
  <xsl:variable name="nbsp" select="'&#xA0;'"/>


  <!-- Match the entire document and process it into a Web page.
       The document properties and body are processed separately
       in a uniform way. The background is provided by this style
   -->
  <xsl:template match="/">
    <xsl:variable name="project" select="document('../project.xml')/project"/>

    <html><head>
      <meta name="author" content="{document/properties/author/.}"/>
      <link rel="stylesheet" type="text/css" href="style/default.css"/>
      <xsl:choose>
        <xsl:when test="/document/properties/title"><title><xsl:value-of select="/document/body/title"/></title></xsl:when>
        <xsl:when test="/document/body/title"><title><xsl:value-of select="/document/body/title"/></title></xsl:when>
        <xsl:otherwise><title><xsl:value-of select="$project/title"/></title></xsl:otherwise>
      </xsl:choose>
    </head>

   <body bgcolor="{$color-alpha}" link="{$color-link}" vlink="{$color-link}" 
    alink="{$color-link}" leftmargin="4" marginheight="4" marginwidth="4" 
    topmargin="4">
      
     <table border="0" cellpadding="0" cellspacing="0" width="100%">
       <tr>
         <td align="left" valign="top">
           <a href="http://jakarta.apache.org">
             <img src="images/jakarta-logo.gif" border="0" 
              vspace="0" hspace="0" align="left"/>
           </a>
         </td>
         <td align="left" valign="top" width="100%" bgColor="#ffffff">
           <img src="images/Slide.gif" border="0" vspace="0" 
            hspace="0" align="right"/>
         </td>
       </tr>
       <tr>
         <td colspan="2" height="2" width="100%">
           <hr/>
         </td>
       </tr>
     </table>

     <table border="0" cellpadding="0" cellspacing="0" width="100%">

        <tr>
          <td bgcolor="{$color-beta}" width="120" rowspan="2" valign="top">
            <xsl:if test="document/properties">
              <xsl:attribute name="rowspan">4</xsl:attribute>
            </xsl:if>
            <table>
              <xsl:for-each select="$project/menu">
                <tr>
                  <td align="left" colspan="2">
                    <font color="{$color-link}"><small><b><xsl:value-of select="@name"/></b></small></font>
                  </td>
                </tr>
                <xsl:for-each select="item">
                  <tr>
                    <td width="15" valign="top" align="right">
                      <img src="style/images/bullets/small-blue.gif" alt="*" height="12" width="12"/>
                    </td>
                    <td><span class="alpha">
                      <xsl:variable name="href">
                        <xsl:call-template name="link-convertor">
                          <xsl:with-param name="href" select="@href"/>
                        </xsl:call-template>
                      </xsl:variable>
                      <font size="2"><a href="{$href}"><xsl:value-of select="@name"/></a></font>
                    </span></td>
                  </tr>
                </xsl:for-each>
              </xsl:for-each>
            </table>
          </td>
          <td bgcolor="{$color-alpha}" width="11" valign="top">
          </td>
          <td bgcolor="{$color-alpha}" height="45" width="3600">
            &#xA0;&#xA0;<img src="style/images/bullets/dots.gif" height="11" width="41" valign="top"/>&#xA0;&#xA0;
            <font size="4" color="{$color-c}"><b>
              <xsl:choose>
                <xsl:when test="/document/body/title"><xsl:value-of select="/document/body/title"/></xsl:when>
                <xsl:otherwise><xsl:value-of select="$project/title"/></xsl:otherwise>
              </xsl:choose>
            </b></font>
           </td>
        </tr>

      <xsl:if test="document/properties">
        <tr>
          <td bgcolor="{$color-alpha}" width="11"><xsl:value-of select="$nbsp"/></td>
          <td bgcolor="{$color-alpha}" valign="top">
             <xsl:apply-templates select="document/properties"/>
          </td>
        </tr>

        <tr>
          <td bgcolor="{$color-beta}" width="11"><xsl:value-of select="$nbsp"/></td>
          <td bgcolor="{$color-beta}" valign="top"><xsl:value-of select="$nbsp"/></td>
        </tr>
      </xsl:if>

        <tr>
          <td bgcolor="{$color-alpha}" width="11">&#xA0;</td>
          <td bgcolor="{$color-alpha}" valign="top">
             <xsl:apply-templates select="document/body"/>
             <br/>
          </td>
        </tr>

        <tr>
          <td bgcolor="{$color-beta}" width="120"></td>
          <td bgcolor="{$color-beta}" height="11" width="11" valign="top">
          </td>
          <td bgcolor="{$color-alpha}" valign="top">
            <img src="style/images/blank.gif" height="11" width="11"/>
          </td>
        </tr>
        <tr>
          <td bgcolor="{$color-beta}" width="120"></td>
          <td bgcolor="{$color-beta}" width="11">
            <img src="style/images/blank.gif" height="11" width="11"/>
          </td>
          <td bgcolor="{$color-beta}" valign="top"></td>
        </tr>

        <xsl:if test="$project/notice">
          <tr>
            <td bgcolor="{$color-beta}" width="120"></td>
            <td bgcolor="{$color-beta}" width="11" valign="top"></td>
            <td bgcolor="{$color-alpha}" valign="top"><img src="style/images/blank.gif" height="11" width="11"/></td>
          </tr>
          <tr>
            <td bgcolor="{$color-beta}" width="120"></td>
            <td bgcolor="{$color-alpha}" width="11">&#xA0;</td>
            <td bgcolor="{$color-alpha}">
              <xsl:for-each select="$project/notice">
                <small><hr/><xsl:copy-of select="."/><br/>&#xA0;<br/></small>
              </xsl:for-each>
            </td>
          </tr>
          <tr>
            <td bgcolor="{$color-beta}" width="120"></td>
            <td bgcolor="{$color-beta}" width="11" valign="top"></td>
            <td bgcolor="{$color-alpha}" valign="top"><img src="style/images/blank.gif" height="11" width="11"/></td>
          </tr>
        </xsl:if>

        <tr>
          <td bgcolor="{$color-beta}" width="120"></td>
          <td bgcolor="{$color-beta}" width="11" valign="top"></td>
          <td bgcolor="{$color-beta}" valign="top">
          </td>
        </tr>

      </table>

    </body>
    </html>
  </xsl:template>

  <!-- Match an attribute list
   -->
  <xsl:template match="attribute-list">
                <table border="1" cellpadding="2" cellspacing="0">
                  <tr>
                    <td>
                      Name
                    </td>
                    <td>
                      Description
                    </td>
                    <td>
                      Required
                    </td>
                  </tr>
    <xsl:for-each select="attribute">
      <tr><td><xsl:value-of select="@name"/></td><td>
      <xsl:value-of select="@description"/></td><td>
      <xsl:value-of select="@required"/></td></tr>
    </xsl:for-each>
                </table>
  </xsl:template>

  <!-- Special handling for project-wide links which appear both at the
       top and bottom of the page
   -->
  <xsl:template match="project/links">
    <xsl:for-each select="link">
      <xsl:variable name="href">
        <xsl:call-template name="link-convertor">
          <xsl:with-param name="href" select="@href"/>
        </xsl:call-template>
      </xsl:variable>
      <a href="{$href}"><img src="{@image}" alt="{@name}" height="{@height}" width="{@width}" border="0" vspace="5"/></a>
    </xsl:for-each>
  </xsl:template>


  <xsl:template match="changelog">
    <table border="0" cellpadding="2" cellspacing="2">
      <xsl:apply-templates/>
    </table>
  </xsl:template>

  <xsl:template match="changelog/add">
    <tr>
      <td><img alt="add" class="icon" src="style/images/add.gif"/></td>
      <td><xsl:apply-templates/></td>
    </tr>
  </xsl:template>

  <xsl:template match="changelog/update">
    <tr>
      <td><img alt="update" class="icon" src="style/images/update.gif"/></td>
      <td><xsl:apply-templates/></td>
    </tr>
  </xsl:template>

  <xsl:template match="changelog/design">
    <tr>
      <td><img alt="design" class="icon" src="style/images/design.gif"/></td>
      <td><xsl:apply-templates/></td>
    </tr>
  </xsl:template>

  <xsl:template match="changelog/docs">
    <tr>
      <td><img alt="docs" class="icon" src="style/images/docs.gif"/></td>
      <td><xsl:apply-templates/></td>
    </tr>
  </xsl:template>

  <xsl:template match="changelog/fix">
    <tr>
      <td><img alt="fix" class="icon" src="style/images/fix.gif"/></td>
      <td><xsl:apply-templates/></td>
    </tr>
  </xsl:template>

  <xsl:template match="changelog/scode">
    <tr>
      <td><img alt="code" class="icon" src="style/images/code.gif"/></td>
      <td><xsl:apply-templates/></td>
    </tr>
  </xsl:template>

  <xsl:template name="link-convertor">
    <xsl:param name="href" select="empty"/>
    <xsl:choose>
      <xsl:when test="starts-with($href,'http:')">
        <xsl:value-of select="$href"/>
      </xsl:when>
      <xsl:when test="not(contains($href,'.xml'))">
        <xsl:value-of select="$href"/>
      </xsl:when>
      <xsl:otherwise><xsl:value-of select="substring-before($href, '.xml')"/>.html</xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <!-- UL is processed into a table using graphical bullets -->
  <xsl:template match="ul">
    <table border="0" cellpadding="2" cellspacing="2">
      <tr><td colspan="2" height="5"></td></tr>
      <xsl:apply-templates/>
    </table>
  </xsl:template>

  <xsl:template match="ul/li">
    <tr>
      <td align="left" valign="top" width="15">
        <img src="style/images/bullets/blue.gif" height="22" width="15" alt="*"/>
     </td>
      <td align="left" valign="top"><xsl:apply-templates/></td>
    </tr>
  </xsl:template>

  <xsl:template match="a">
    <xsl:variable name="href">
      <xsl:call-template name="link-convertor">
        <xsl:with-param name="href" select="@href"/>
      </xsl:call-template>
    </xsl:variable>
    <a href="{$href}"><xsl:apply-templates/></a>
  </xsl:template>


  <xsl:template match="status">
    <table border="1" width="90%">
      <tr>
        <th width="10%">Priority</th>
        <th width="60%">Action Item</th>
        <th width="30%">Volunteers</th>
      </tr>
      <xsl:apply-templates/>
    </table>
  </xsl:template>


  <xsl:template match="status/item">
    <tr>
      <td align="center"><xsl:value-of select="@priority"/></td>
      <td>
        <xsl:apply-templates/>
      </td>
      <td><xsl:value-of select="@owner"/></td>
    </tr>
  </xsl:template>


  <xsl:template match="img">
    <img src="{@src}"><xsl:apply-templates/></img>
  </xsl:template>


</xsl:stylesheet>


