/*
 * $Header: /home/cvspublic/jakarta-slide/src/share/org/apache/slide/common/XMLMarshaller.java,v 1.6 2000/11/25 01:34:50 remm Exp $
 * $Revision: 1.6 $
 * $Date: 2000/11/25 01:34:50 $
 *
 * ====================================================================
 *
 * The Apache Software License, Version 1.1
 *
 * Copyright (c) 1999 The Apache Software Foundation.  All rights 
 * reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer. 
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution, if
 *    any, must include the following acknowlegement:  
 *       "This product includes software developed by the 
 *        Apache Software Foundation (http://www.apache.org/)."
 *    Alternately, this acknowlegement may appear in the software itself,
 *    if and wherever such third-party acknowlegements normally appear.
 *
 * 4. The names "The Jakarta Project", "Tomcat", and "Apache Software
 *    Foundation" must not be used to endorse or promote products derived
 *    from this software without prior written permission. For written 
 *    permission, please contact apache@apache.org.
 *
 * 5. Products derived from this software may not be called "Apache"
 *    nor may "Apache" appear in their names without prior written
 *    permission of the Apache Group.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 *
 * This software consists of voluntary contributions made by many
 * individuals on behalf of the Apache Software Foundation.  For more
 * information on the Apache Software Foundation, please see
 * <http://www.apache.org/>.
 *
 * [Additional notices, if required by prior licensing conditions]
 *
 */ 

package org.apache.slide.common;

import java.util.Hashtable;
import java.util.Vector;
import java.util.Enumeration;
import java.util.Stack;
import java.util.Date;
import java.io.Reader;
import java.io.Writer;
import org.apache.slide.structure.*;
import org.apache.slide.content.*;
import org.apache.slide.lock.*;
import org.apache.slide.security.*;
import org.apache.slide.authenticate.CredentialsToken;

/**
 * XMLMarshaller helper class.
 * 
 * @author <a href="mailto:remm@apache.org">Remy Maucherat</a>
 * @version $Revision: 1.6 $
 */
public final class XMLMarshaller {
    
    
    // --------------------------------------------------------- Public Methods
    
    
    /**
     * Saves Slide Data to XML.
     * 
     * @param writer Writer 
     * @param startNode Start generating XML from this node of the Slide tree
     * @exception SlideException 
     */
    public static void marshal(NamespaceAccessToken accessToken, 
                               SlideToken token, Writer writer, 
                               String startNode)
	throws SlideException {
        /*
	try {
	    // Retrieve the start element
	    ObjectNode object = 
                accessToken.getStructureHelper().retrieve(token, startNode);
	    // Generate an associated Castor object representing the ObjectNode
	    org.apache.slide.common.xml.Objectnode slideObjectDef =
		new org.apache.slide.common.xml.Objectnode();
	    saveObjectNode(accessToken, token, object, slideObjectDef);
	    // Marshal the Castor object to the Writer
	    slideObjectDef.marshal(writer);
	} catch (Exception e) {
	    e.printStackTrace();
	}
	*/
    }
    
    
    // -------------------------------------------------------- Private Methods
    
    
    /**
     * Save a ObjectNode to a Castor ObjectNode.
     * 
     * @param object Slide Object
     * @param objectDef Castor ObjectNode definition
     */
    /*
    private static void saveObjectNode
        (NamespaceAccessToken accessToken, CredentialsToken token, 
         ObjectNode object, org.apache.slide.common.xml.Objectnode objectDef) {
        
        // Set the basic fields of the Castor object
        objectDef.setClassname(object.getClass().getName());
        objectDef.setUri(object.getUri().toString());
        
        // If the object is or derives from the LinkNode class, we must also 
        // save it's additional linkedUri field
        if (object instanceof LinkNode) {
            objectDef.setTarget(((LinkNode) object).getLinkedUri().toString());
	}
        
        try {
            // Save permissions associated with the Slide Object
            Enumeration permissions = accessToken.getSecurityHelper()
                .enumeratePermissions(token, object);
            while (permissions.hasMoreElements()) {
                NodePermission permission = 
                    (NodePermission) permissions.nextElement();
                org.apache.slide.common.xml.Permission permissionDef =
                    new org.apache.slide.common.xml.Permission();
                permissionDef.setSubject
                    (permission.getSubjectUri().toString());
                permissionDef.setAction(permission.getActionUri().toString());
                permissionDef.setInheritance
                    ((new Boolean(permission.isInheritable())).toString());
                objectDef.addPermission(permissionDef);
            }
    */
            // Saving version information
            /*
              SlideProperties properties = accessToken.getStructureHelper()
              .retrieve(token, object);
              org.apache.slide.common.xml.Properties propertiesDef =
              new org.apache.slide.common.xml.Properties();
              
              propertiesDef.setContentlanguage
              (properties.getContentLanguage());
              propertiesDef.setContenttype(properties.getContentType());
              if (properties.getCreationDateAsDate() != null) {
              propertiesDef.setCreationdate
              ((new Long(properties.getCreationDateAsDate()
              .getTime())).toString());
              } else {
              propertiesDef.setCreationdate(properties.getCreationDate());
              }
              //propertiesDef.setLatestrevisionid(properties
              //.getLatestRevisionId().toString());
              propertiesDef.setName(properties.getName());
              
              Enumeration revisionIdsList = accessToken.getContentHelper()
              .enumerate(token, properties);
              while (revisionIdsList.hasMoreElements()) {
              SlideRevisionId revisionId = 
              (SlideRevisionId) revisionIdsList.nextElement();
              SlideRevision revision = accessToken.getContentHelper()
              .retrieve(token, properties, revisionId);
              
              org.apache.slide.common.xml.Revision revisionDef =
              new org.apache.slide.common.xml.Revision();
              
              revisionDef.setAuthor(revision.getAuthor());
              revisionDef.setCreationdate
              ((new Long(revision.getCreationDate().getTime())).toString());
              revisionDef.setId(revision.getId().toString());
              revisionDef.setName(revision.getName());
              propertiesDef.addRevision(revisionDef);
              }
              objectDef.setProperties(propertiesDef);
            */
    /*
      } catch(SlideException e) {
	}
	
	// Now, we parse all the children of this object
	try {
	    Enumeration childObjects = accessToken
                .getStructureHelper().getChildren(token, object);
	    while (childObjects.hasMoreElements()) {
		ObjectNode currentObject = 
                    (ObjectNode) childObjects.nextElement();
		org.apache.slide.common.xml.Objectnode currentObjectDef =
		    new org.apache.slide.common.xml.Objectnode();
		// Recursive call to this function
		saveObjectNode(accessToken, token, currentObject, 
                               currentObjectDef);
		objectDef.addObjectnode(currentObjectDef);
	    }
	} catch(SlideException e) {
	}
	
    }
*/  
}
