/*
 * $Header: /home/cvspublic/jakarta-slide/src/stores/slidestore/reference/fileDeleter/DeleterWalker.java,v 1.1 2001/02/26 13:46:14 juergen Exp $
 * $Revision: 1.1 $
 * $Date: 2001/02/26 13:46:14 $
 *
 * ====================================================================
 *
 * The Apache Software License, Version 1.1
 *
 * Copyright (c) 1999 The Apache Software Foundation.  All rights
 * reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution, if
 *    any, must include the following acknowlegement:
 *       "This product includes software developed by the
 *        Apache Software Foundation (http://www.apache.org/)."
 *    Alternately, this acknowlegement may appear in the software itself,
 *    if and wherever such third-party acknowlegements normally appear.
 *
 * 4. The names "The Jakarta Project", "Tomcat", and "Apache Software
 *    Foundation" must not be used to endorse or promote products derived
 *    from this software without prior written permission. For written
 *    permission, please contact apache@apache.org.
 *
 * 5. Products derived from this software may not be called "Apache"
 *    nor may "Apache" appear in their names without prior written
 *    permission of the Apache Group.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 *
 * This software consists of voluntary contributions made by many
 * individuals on behalf of the Apache Software Foundation.  For more
 * information on the Apache Software Foundation, please see
 * <http://www.apache.org/>.
 *
 * [Additional notices, if required by prior licensing conditions]
 *
 */

package slidestore.reference.fileDeleter;

//Java import
import java.io.*;

public class DeleterWalker {
    
    
    private DirectoryFilter filter;
    
    /**
     * Constructor. The starting path (eg C:\, D:\TEMP\) is passed to start the Walker
     * @param     String
     * @param     String[]
     */
    public DeleterWalker(String path, String[] filterValues) {
        filter = new DirectoryFilter();
        for (int i = 0; i < filterValues.length; i++) {
            filter.addFileName(filterValues[i]);
        }
        walkDirectory(path);
    }
    
    /**
     * This allows Walker to walk through the directories looking for files of the given filter
     * @param     String
     * @param     int
     * @param     String
     */
    public void walkDirectory(String path) {
        try {
            File rootFile = new File(path);
            String[] fileList = rootFile.list();
            for (int i = 0; i < fileList.length; i++) {
                File currentFile = new File(path+"\\"+fileList[i]);
                if (currentFile.isDirectory()) {
                    walkDirectory(path+"\\"+currentFile.getName());
                }
                if (filter.accept(currentFile,path) ) {
                    currentFile.delete();
                    File newFile = new File(path);
                    String[] check = newFile.list();
                    if (check.length == 0) {
                        if (!(newFile.delete() ))
                            System.out.println("UNABLE TO DELETE DIRECTORY "+newFile.getPath());
                    }
                }
                
            }
        }
        catch (Exception e) {
            e.printStackTrace();
        }
    }
    
    
    
}
